;;;; objc-header.scm

(use objc cocoa)

#>
#import <Cocoa/Cocoa.h>
<#

#;(define (macro:type->encoding x)
	(cond
		[(symbol? x)
			(string->symbol (string-append "objc:" (symbol->string x)))]
		[(list? x)
			(cons (macro:type->encoding (car x)) (cdr x))]
		[else
			x]))

(define-foreign-variable NSCocoaErrorDomain c-pointer)

(define-foreign-variable NULL c-pointer)

(define nil (objc:instance->pointer #f))

(define Nil (objc:instance->pointer #f))

(define-macro (selector@ ID)
	`(string->selector (conc ',ID)))

(define-macro (gen-ID TYPE)
	`(define-macro (,(string->symbol (conc #;"objc:" TYPE "*")))
		'objc:ID))

(define-macro (gen-PTR TYPE)
	`(define-macro (,(string->symbol (conc #;"objc:" TYPE "**")))
		'objc:PTR))

(define-macro (gen-VOID TYPE)
	`(define-macro (,TYPE)
		'objc:VOID))

(gen-ID NSString)
(gen-ID NSAttributedString)
(gen-ID NSTimer)
(gen-ID NSWindowController)
(gen-ID NSError)
(gen-ID NSData)
(gen-ID NSNotification)

(gen-PTR NSError)

(gen-VOID IBAction)

(define-macro (define-simple-foreign-enum . ITEMS)
	`(begin
		,@(map
				(match-lambda 
					[(name realname) `(define-foreign-variable ,name int ,realname)]
					[name `(define-foreign-variable ,name int)] )
			ITEMS) ) )

(define-simple-foreign-enum
	NSChangeDone
	NSChangeUndone
	NSChangeCleared
)

(define-simple-foreign-enum
	NSASCIIStringEncoding
	NSNEXTSTEPStringEncoding
	NSJapaneseEUCStringEncoding
	NSUTF8StringEncoding
	NSISOLatin1StringEncoding
	NSSymbolStringEncoding
	NSNonLossyASCIIStringEncoding
	NSShiftJISStringEncoding
	NSISOLatin2StringEncoding
	NSUnicodeStringEncoding
	NSWindowsCP1251StringEncoding
	NSWindowsCP1252StringEncoding
	NSWindowsCP1253StringEncoding
	NSWindowsCP1254StringEncoding
	NSWindowsCP1250StringEncoding
	NSISO2022JPStringEncoding
	NSMacOSRomanStringEncoding
	NSProprietaryStringEncoding
)

(define-simple-foreign-enum
   NSFileNoSuchFileError
   NSFileLockingError
   NSFileReadUnknownError
   NSFileReadNoPermissionError
   NSFileReadInvalidFileNameError
   NSFileReadCorruptFileError
   NSFileReadNoSuchFileError
   NSFileReadInapplicableStringEncodingError
   NSFileReadUnsupportedSchemeError
   NSFileWriteUnknownError
   NSFileWriteNoPermissionError
   NSFileWriteInvalidFileNameError
   NSFileWriteInapplicableStringEncodingError
   NSFileWriteUnsupportedSchemeError
   NSFileWriteOutOfSpaceError
   NSKeyValueValidationError
   NSFormattingError
   NSUserCancelledError
   NSFileErrorMinimum
   NSFileErrorMaximum
   NSValidationErrorMinimum
   NSValidationErrorMaximum
   NSFormattingErrorMinimum
   NSFormattingErrorMaximum
 )

#|
(define-foreign-enum (NSDocumentChangeType (enum "_NSDocumentChangeType"))
	NSChangeDone
	NSChangeUndone
	NSChangeCleared
)

(define-foreign-enum (NSStringEncoding unsigned-int)
	NSASCIIStringEncoding
	NSNEXTSTEPStringEncoding
	NSJapaneseEUCStringEncoding
	NSUTF8StringEncoding
	NSISOLatin1StringEncoding
	NSSymbolStringEncoding
	NSNonLossyASCIIStringEncoding
	NSShiftJISStringEncoding
	NSISOLatin2StringEncoding
	NSUnicodeStringEncoding
	NSWindowsCP1251StringEncoding
	NSWindowsCP1252StringEncoding
	NSWindowsCP1253StringEncoding
	NSWindowsCP1254StringEncoding
	NSWindowsCP1250StringEncoding
	NSISO2022JPStringEncoding
	NSMacOSRomanStringEncoding
	NSProprietaryStringEncoding
)

(define-foreign-enum (NSErrorCode unsigned-int)
   NSFileNoSuchFileError
   NSFileLockingError
   NSFileReadUnknownError
   NSFileReadNoPermissionError
   NSFileReadInvalidFileNameError
   NSFileReadCorruptFileError
   NSFileReadNoSuchFileError
   NSFileReadInapplicableStringEncodingError
   NSFileReadUnsupportedSchemeError
   NSFileWriteUnknownError
   NSFileWriteNoPermissionError
   NSFileWriteInvalidFileNameError
   NSFileWriteInapplicableStringEncodingError
   NSFileWriteUnsupportedSchemeError
   NSFileWriteOutOfSpaceError
   NSKeyValueValidationError
   NSFormattingError
   NSUserCancelledError
   NSFileErrorMinimum
   NSFileErrorMaximum
   NSValidationErrorMinimum
   NSValidationErrorMaximum
   NSFormattingErrorMinimum
   NSFormattingErrorMaximum
 )
|#
